if(select(2, UnitClass('player')) ~= 'PALADIN') then return end

local parent, ns = ...
local oUF = ns.oUF

local SPELL_POWER_HOLY_POWER = SPELL_POWER_HOLY_POWER
local COLORS = {228/255,225/255,16/255}

local Update = function(self, event, unit, powerType)
    if(self.unit ~= unit or (powerType and powerType ~= 'HOLY_POWER')) then return end

    local hp = self.HolyPower
    local num = UnitPower(unit, Enum.PowerType.HolyPower)
    local numMax = UnitPowerMax('player', Enum.PowerType.HolyPower)
    local spec = GetSpecialization()
	
	if spec ~= 3 then
		num = 0
	end
    
    if(hp.PreUpdate) then 
        hp:PreUpdate()
    end
    
    if num > 0 then
        hp:Show()
    else
        hp:Hide()
    end

    for i = 1, numMax do
        if(i <= num) then
            self.HolyPower[i]:SetAlpha(1)
        else
            self.HolyPower[i]:SetAlpha(.2)
        end
    end

    if(hp.PostUpdate) then
        return hp:PostUpdate(num)
    end
end

local Path = function(self, ...)
    return (self.HolyPower.Override or Update) (self, ...)
end

local ForceUpdate = function(element)
    return Path(element.__owner, 'ForceUpdate', element.__owner.unit, 'HOLY_POWER')
end

local function Enable(self)
    local hp = self.HolyPower
    if(hp) then
        hp.__owner = self
        hp.ForceUpdate = ForceUpdate

        self:RegisterEvent('UNIT_POWER_UPDATE', Path)

        for i = 1, 5 do
            if not hp[i]:GetStatusBarTexture() then
                hp[i]:SetStatusBarTexture([=[Interface\TargetingFrame\UI-StatusBar]=])
            end

            hp[i].width = hp[i]:GetWidth()
        end

        hp:Hide()

        return true
    end
end

local function Disable(self)
    local hp = self.HolyPower
    if(hp) then
        self:UnregisterEvent('UNIT_POWER_UPDATE', Path)
    end
end

oUF:AddElement('HolyPower', Path, Enable, Disable)
